//Passwd.java provides password checking facility for Quiz.java

import java.io.*;
import java.awt.*;
import java.awt.event.*;

class Passwd extends Frame {
  private Label explainName,explainPassword,responsePassword;
  private TextField enterName,enterPassword;
  private NameListener nameListener;
  private PasswordListener passwordListener;
  String existsPassword="", newPassword="", password="", userName="";
  private boolean passwordMatched=false;
  Quiz quiz;
  
  public Passwd( Quiz q )
  {  
     super(  "Welcome!  Please login before starting UM quiz");
     setBounds(200,200,400,150);         //center the Passwd component on the screen
     setLayout(new GridLayout(6, 1)); 
     
     quiz = q;
     
     try //get passwords from QuizServer
     { existsPassword = quiz.quizInput.readLine(); //ignore first line
       existsPassword = quiz.quizInput.readLine().trim();  
       newPassword = quiz.quizInput.readLine().trim();
     }
     catch ( IOException e )
     { System.err.println("Error while getting quiz passwords from server\n" + e.toString() );
       System.exit(1);
      }
 
     //Set up listeners to respond when user hits Enter in a TextField
     nameListener = new NameListener();  passwordListener = new PasswordListener();
     
     //Set up Label and TextField for user's name
     Font explainFont = new Font ( "Arial",Font.BOLD,12 );
     explainName = new Label("Enter your last name:");
     explainName.setFont( explainFont );
     enterName = new TextField("",20);
     enterName.addActionListener( nameListener );  //listen for Return character
     add( explainName ); add( enterName );
     setVisible(true);
     
     //Set up Label and TextField for password
     explainPassword = new Label("Ask instructor to enter the password:");
     explainPassword.setFont(explainFont);
     enterPassword = new TextField("",10);
     enterPassword.setEchoChar('*');
     enterPassword.addActionListener( passwordListener );
     add( explainPassword ); add( enterPassword );
     
     //Set up Label in which this program responds to erroneous user input
     responsePassword = new Label("");
     responsePassword.setFont( explainFont );
     add( responsePassword );
     addWindowListener( new CloseWindowAndExit() );

     while (!passwordMatched)  //Look for one of two valid passwords before continuing
      {  while (userName.equals("") );  //wait for user to enter name
         enterPassword.setVisible(true); 
         enterPassword.requestFocus();
         setVisible(true); repaint();
         while (password.equals("") ) ;  //wait for user to enter password
         passwordMatched = checkName(userName,password);
         if (!passwordMatched)
         {  enterPassword.setText(""); userName=password="";
            enterPassword.setVisible(false); explainPassword.setVisible(false); 
            enterName.requestFocus(); repaint();
         }          
      } //while !passwordMatched
 
     dispose();  //erase Passwd frame
  } //Passwd() constructor
    
  class  NameListener implements ActionListener
  //Respond when user hits Enter in TextField enterName
   { public void actionPerformed( ActionEvent e )
     { userName = e.getActionCommand(); 
     }
   } //NameListener
  
  class  PasswordListener implements ActionListener
  //Respond when user hits Enter in TextField enterPassword
  {  public void actionPerformed( ActionEvent e )
     { password = e.getActionCommand(); 
     }
   } //PasswordListener
   
   boolean checkName(String userName,String password)
   { String serverReply;  //hold reply from server
      try
      { if (password.equals(existsPassword))
         { quiz.quizOutput.writeUTF("find=" + userName);
            serverReply = quiz.quizInput.readLine();
            if (serverReply.regionMatches(2,"no",0,2))  //ignore spurious character in transmission
            { responsePassword.setText("Did you mis-spell your name or are you a new user?  Try again?");
               return false;
            }
            else if (serverReply.regionMatches(2,"taken",0,5)) 
            { responsePassword.setText("You've taken this quiz already and can't retake it.");
              return false;
            }
           else return true;
          }
          else if (password.equals(newPassword)) 
          { quiz.quizOutput.writeUTF("new=" + userName);
            serverReply=quiz.quizInput.readLine();
           if (serverReply.regionMatches(2,"no",0,2))  //ignore spurious character in transmission
             { responsePassword.setText("There's already a student by this name.  Try adding your initials.");
               return false;
             }
             else return true;
            }
          else 
          {  responsePassword.setText("Invalid password. Try again!"); 
             return false;
          }
       } //try
      catch ( IOException ex )
      { System.err.println("Error while checking name with server\n" + ex.toString() );
        System.exit(1);
      }
      return false;
    } //actionPerformed()

} //class Passwd
